# This file was auto-generated by Fern from our API Definition.

from .environment import PushCashEnvironment
from .resources.balance.client import AsyncBalanceClient, BalanceClient
from .resources.events.client import AsyncEventsClient, EventsClient
from .resources.intent.client import AsyncIntentClient, IntentClient
from .resources.transfer.client import AsyncTransferClient, TransferClient
from .resources.user.client import AsyncUserClient, UserClient


class PushCash:
    def __init__(self, *, environment: PushCashEnvironment = PushCashEnvironment.PRODUCTION, token: str):
        self._environment = environment
        self._token = token
        self.balance = BalanceClient(environment=self._environment, token=self._token)
        self.events = EventsClient(environment=self._environment, token=self._token)
        self.intent = IntentClient(environment=self._environment, token=self._token)
        self.transfer = TransferClient(environment=self._environment, token=self._token)
        self.user = UserClient(environment=self._environment, token=self._token)


class AsyncPushCash:
    def __init__(self, *, environment: PushCashEnvironment = PushCashEnvironment.PRODUCTION, token: str):
        self._environment = environment
        self._token = token
        self.balance = AsyncBalanceClient(environment=self._environment, token=self._token)
        self.events = AsyncEventsClient(environment=self._environment, token=self._token)
        self.intent = AsyncIntentClient(environment=self._environment, token=self._token)
        self.transfer = AsyncTransferClient(environment=self._environment, token=self._token)
        self.user = AsyncUserClient(environment=self._environment, token=self._token)
