# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class TransactionFeeType(str, enum.Enum):
    """
    Type of the fee
    """

    USER_SETUP_FEE = "user_setup_fee"
    INITIATION_FEE = "initiation_fee"
    PUSH_TXN_FEE = "push_txn_fee"

    def visit(
        self,
        user_setup_fee: typing.Callable[[], T_Result],
        initiation_fee: typing.Callable[[], T_Result],
        push_txn_fee: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is TransactionFeeType.USER_SETUP_FEE:
            return user_setup_fee()
        if self is TransactionFeeType.INITIATION_FEE:
            return initiation_fee()
        if self is TransactionFeeType.PUSH_TXN_FEE:
            return push_txn_fee()
