# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class TransactionStatus(str, enum.Enum):
    """
    Indicates how the funds from the transaction are represented in the account balance
    """

    PENDING = "pending"
    AVAILABLE = "available"

    def visit(self, pending: typing.Callable[[], T_Result], available: typing.Callable[[], T_Result]) -> T_Result:
        if self is TransactionStatus.PENDING:
            return pending()
        if self is TransactionStatus.AVAILABLE:
            return available()
